     PROGRAM CMain

     USE Hankel_Single

     IMPLICIT NONE

     INTEGER  n, ifail
     COMPLEX, DIMENSION(:), ALLOCATABLE :: h, b, x

     INTEGER  k
     REAL, DIMENSION(:), ALLOCATABLE :: random, ones

     INTERFACE
       FUNCTION Hankel(n,h)
         INTEGER n
         COMPLEX h(0:2*n-2)
         COMPLEX Hankel(n,n)
       END FUNCTION Hankel
     END INTERFACE
!-----------------------------------------------------------------------
     n = 5 

     ALLOCATE(h(0:2*n-2)); ALLOCATE(b(n)); ALLOCATE(x(n))

     ALLOCATE(ones(n)); ones = 1.
     ALLOCATE(random(0:2*n-2)); CALL RANDOM_NUMBER(random)
     h = random
     b = MATMUL(Hankel(n,h),ones)
 
     ifail = -1
     CALL CHankel(n,h,b,x,nref=2,ifail=ifail)

     IF (ifail == 0) THEN
       PRINT *, 'x = '
       DO k = 1, n
         PRINT 9000, REAL(x(k)), AIMAG(x(k))
       END DO
     END IF

9000 FORMAT (ES15.7,' + i',ES15.7)

     END PROGRAM CMain
!
!-----------------------------------------------------------------------
!
     FUNCTION Hankel(n,h)
       INTEGER n, k, l
       COMPLEX h(0:2*n-2)
       COMPLEX Hankel(n,n) 

       DO k = 1,n
         DO l = 1,n
           Hankel(k,l) = h(k+l-2)
         END DO
       END DO
     END FUNCTION Hankel
